--- amarok/src/osd.h.orig	2011-09-27 17:47:26.000000000 +0300
+++ amarok/src/osd.h	2011-09-27 17:47:43.000000000 +0300
@@ -37,7 +37,7 @@
 
       public slots:
         /** calls setText() then show(), after setting image if needed */
-        void show( const QString &text, QImage newImage = QImage::QImage() );
+        void show( const QString &text, QImage newImage = QImage() );
         void ratingChanged( const short rating );
         void ratingChanged( const QString& path, int rating );
         void volChanged( unsigned char volume );